#include <sys/socket.h>//consts and procedures
#include <sys/types.h>
#include <iostream.h>
#include <string.h>    //for bzero
#include <arpa/inet.h> //for sockadd_in !!!
#include <unistd.h>    //for close()
#include <conio.h>
#include <fcntl.h>     //non-blocking
#include <time.h>      //for user select

#include <lsck/lsck.h> //for lsck_strerror

#include <stdlib.h>    //for atexit()
#include <sys/exceptn.h>//for ctrl-c

#define STDIN 0

const short MYPORT = 3490;
const int   MAXCLI = 5;

#include "window.h"

char* EnterName();
void  MakeScreen();

void  ClearKeys();

sockaddr_in ina;       //IP address -- server
sockaddr_in theirs;    //Temp IP

char  buf = 0;
char  msg = 0;

int   list = -1;       //Listening socket
int   conn[MAXCLI];    //Client sockets
int   clients = 0;     //# of clients

bool  timeout = false; //For custom select()
/*
fd_set  read_set;      //For select()
timeval timeout;
*/

char* thisname;        //Name of this user

Window Server;
Window Clients[MAXCLI];

int   bytes_recv = 0;
int   bytes_sent = 0;

int   temp = 0;

void DisplayError() {
  cout << endl << "errno: " << errno << " -- " << lsck_strerror(errno) << endl;
}

int main() {
  atexit(DisplayError);
  __djgpp_set_ctrl_c(0);

  clrscr();
  thisname = EnterName();
  Server.SetName(thisname);

  bzero(&ina, sizeof(ina));
  ina.sin_family = AF_INET;
  ina.sin_port = htons(MYPORT);
  ina.sin_addr.s_addr = htonl(INADDR_ANY);

  list = socket(AF_INET, SOCK_STREAM, 0);
  if (list == -1)
    return 1;

  temp = 1;
  setsockopt(list, SOL_SOCKET, SO_REUSEADDR, (void*)&temp, sizeof(temp));

  if (bind(list, (sockaddr *)&ina, sizeof(sockaddr)))
    return 2;

  cout << "Listening. . .  Press a key to cancel" << endl;
  if (listen(list, MAXCLI))
    return 3;

  timeout = true;
  errno = 0;
/*
// non-block accept() calling
  fcntl(list, F_SETFL, O_NONBLOCK|fcntl(list, F_GETFL));
  while (timeout && !kbhit()) {
    int sin_size = sizeof(sockaddr_in);
    if ((conn[clients] = accept(list, (sockaddr *)&theirs, &sin_size)) == -1) {
      if (errno != EWOULDBLOCK)
        return 4;
    } else {
      timeout = false;
    }
    cout << "Polling. . ." << endl;
  }
*/

//select() calling
//  timeval tv = {3, 0};
  fd_set readfds;

  FD_ZERO(&readfds);
  FD_SET(list, &readfds);
  FD_SET(STDIN, &readfds);
  errno = 0;
  temp = select(list+1, &readfds, NULL, NULL, NULL);
  cout << "Select returned: " << temp << endl;
  cout << "Errno returned by select: " << errno << endl;
  errno = 0;
  if (FD_ISSET(list, &readfds)) {
    timeout = false;
    int sin_size = sizeof(sockaddr_in);
    if ((conn[clients] = accept(list, (sockaddr *)&theirs, &sin_size)) == -1) {
      cout << "Accept returned: " << conn[clients] << endl;
      cout << "Errno returned by accept(): " << errno << endl;
      return 4;
    }
    cout << "Accept returned: " << conn[clients] << endl;
    cout << "Errno returned by accept(): " << errno << endl;
  } else
    timeout = true;

//Test for Connection
  if (timeout) {
    cout << "Timed out. . ." << endl;
    close(list);
    return 4;
  }

  close(list);

  buf = char(strlen(thisname));
  send(conn[clients], &buf, 1, 0);
  temp = 0;
  while (temp < int(buf)) {
    temp += send(conn[clients], &(thisname[temp]), buf, 0);
  }
  temp = 0;
  recv(conn[clients], &buf, 1, 0);
  char *cliname = new char[buf+1];
  cliname[buf] = '\0';
  while (temp < int(buf)) {
    temp += recv(conn[clients], &(cliname[temp]), buf-temp, 0);
  }
  Clients[clients].SetName(cliname);
  clients++;

  ClearKeys();
  MakeScreen();
  fcntl(conn[0], F_SETFL, O_NONBLOCK|fcntl(conn[0], F_GETFL));
  temp = bytes_recv = bytes_sent = 0;
  while ((msg != 27) && (buf != 27)) {
    temp = recv(conn[0], &buf, 1, 0);
    if (temp != -1) {
      bytes_recv += temp;
      Clients[0] << buf;
    }
    if (kbhit()) {
      msg = getch();
      Server << msg;
      bytes_sent += send(conn[0], &msg, 1, 0);
      if (msg == 13) //if return
        ungetch(10); //send linefeed
    }
  }
  window(1, 1, 80, 25);
  clrscr();
  cout << endl << "Total bytes recieved: " << bytes_recv;
  cout << endl << "Total bytes sent    : " << bytes_sent;

  close(conn[0]);
  delete[] thisname;
  delete[] cliname;
  return 0;
}

char* EnterName() {
  char* ret = new char[50];
  cout << "Enter your name: ";
  cin.getline(ret, 49, '\n');
  return ret;
}

void MakeScreen() {
  int step = 24 / (clients+1);
  int pos = step;
  Server.SetPosition(1, step);
  Server.DrawWindow();
  for (int w=0; w<clients; w++) {
    Clients[w].SetPosition(pos+1, pos+step);
    Clients[w].DrawWindow();
    pos += step;
  }
}

void ClearKeys() {
  char trash;
  while (kbhit())
    trash = getch();
}
